﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Csbot.Core
{
    /// <summary>
    /// This class implements the ISender interface and represents a host sending messages on IRC (such as the IRCd itself).
    /// </summary>
    class Host : ISender
    {
        public String host { get; set; }
        public String nick { get; set; }
        public String realname { get; set; }

        /// <summary>
        /// Public constructor for the class.
        /// </summary>
        /// <param name="host">The hostname of the host.</param>
        public Host(String host)
        {
            this.host = host;
            this.nick = null;
            this.realname = null;
        }
    }
}
