﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Csbot.Core
{
    /// <summary>
    /// This class does all the parsing for actual bot commands.
    /// </summary>
    class Parser
    {
        public static void Run(object param)
        {
            ParserParameters vars = (ParserParameters)param;

            if (vars.config.masters.Contains(vars.received.author.nick)) //no need to check for stuff to be not null, a command can only be issued by a User.
            {
                // %quit
                if ("quit".Equals(vars.received.command))
                {
                    vars.ircOut.Close();
                    Environment.Exit(0);
                }

                // %join #channel
                if ("join".Equals(vars.received.command))
                {
                    vars.config.channels.Add(vars.received.text.Split(' ')[1]);
                    Message join = new Message();
                    join.line = "JOIN " + vars.received.text.Split(' ')[1];
                    join.Send(vars.ircOut, vars.config.debug);
                }

                // %part #channel
                if ("part".Equals(vars.received.command))
                {
                    vars.config.channels.Remove(vars.received.text.Split(' ')[1]);
                    Message part = new Message();
                    part.line = "PART " + vars.received.text.Split(' ')[1];
                    part.Send(vars.ircOut, vars.config.debug);
                }

                // %masteradd nick
                if ("masteradd".Equals(vars.received.command))
                {
                    vars.config.masters.Add(vars.received.text.Split(' ')[1]);
                }

                // %masterdel nick
                if ("masterdel".Equals(vars.received.command))
                {
                    vars.config.masters.Remove(vars.received.text.Split(' ')[1]);
                }
            }

            // %roll ndn
            if ("roll".Equals(vars.received.command))
            {
                int dice = Convert.ToInt32(vars.received.text.Split(' ')[1].Split('d')[0]);
                int num = Convert.ToInt32(vars.received.text.Split(' ')[1].Split('d')[1]);
                Random r = new Random();
                int result = r.Next(dice * num);
                Message res = new Message();
                res.line = "PRIVMSG " + vars.received.channel + " :" + result.ToString();
                res.Send(vars.ircOut, vars.config.debug);
            }
            
            // %lastfm
        }
    }
}
